=== docs/requirements.txt ===
# These are the requirements for readthedoc
docutils
Sphinx>=4.4.0
setuptools>=51.0.0
sphinx-rtd-theme>=3.0.0
sphinx-tabs>=3.4.0
