=== debian/changelog ===
ecflow (5.15.1-3) unstable; urgency=medium

  * Team upload
  * Drop fuse support (Closes: #1122523)

 -- Bastian Germann <bage@debian.org>  Fri, 12 Dec 2025 19:58:57 +0100

ecflow (5.15.1-2) unstable; urgency=medium

  * Add libcrypt-dev to build-deps. Closes: #1106909

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 22 Nov 2025 11:14:22 +0000

ecflow (5.15.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 20 Oct 2025 16:11:58 +0100
