## ecflow 5.15.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
 # Project
 # =========================================================================================
 
-project( ecflow LANGUAGES CXX VERSION 5.15.1 )
+project( ecflow LANGUAGES CXX VERSION 5.15.2 )
 #
 # Important:
 #   The CMake project version is used, as generated CMake variables, to filter .../ecflow/core/ecflow_version.h.in
