=== docs/requirements.txt ===
--- 
+++ 
@@ -4,3 +4,4 @@
 setuptools>=51.0.0
 sphinx-rtd-theme>=3.0.0
 sphinx-tabs>=3.4.0
+sphinx-copybutton>=0.5.0
