=== debian/changelog ===
ecflow (5.15.2-2) unstable; urgency=medium

  * Team upload
  * Drop fuse support again (Closes: #1122523)
  * d/copyright: Fix lately introduced shortname change

 -- Bastian Germann <bage@debian.org>  Fri, 09 Jan 2026 22:55:29 +0100

ecflow (5.15.2-1) unstable; urgency=medium

  * New upstream release
  * Now use pristine-tar
  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Update d/copyright

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 24 Dec 2025 08:21:06 +0000
