=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: ecflow
 Section: science
-Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13), 
@@ -28,9 +27,9 @@
   libboost-regex-dev, 
   libboost-python-dev (>= 1.71.0-7+b1), 
   libboost-program-options-dev, libboost-filesystem-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://software.ecmwf.int/wiki/display/ECFLOW/The+ECFLOW+Pre-processor
-Vcs-Browser: https://salsa.debian.org/science-team/ecflow.git
+Vcs-Browser: https://salsa.debian.org/science-team/ecflow
 Vcs-Git: https://salsa.debian.org/science-team/ecflow.git -b debian/latest
